freeslot("SPR_BCHR","S_BULLETCHARGE","SPR_BGOT","S_BULLETRETICLE")
states[S_BULLETCHARGE] = {SPR_BCHR,FF_SEMIBRIGHT|FF_ANIMATE,35,nil,F,6,S_NULL}
states[S_BULLETRETICLE] = {SPR_BGOT,FF_SEMIBRIGHT|FF_TRANS20,35,nil,0,0,S_NULL}

addHook("AbilitySpecial", function(player)
	if not (player.valid and player.mo and player.mo.valid) then return end
	if (player.charability != CA_THOK) then return end
	
	if not (player.pflags & PF_THOKKED)
		player.mun_starthold = TICRATE
		player.pflags = $|PF_THOKKED|PF_FORCESTRAFE
		
		if player.mun_chargeoverlay and player.mun_chargeoverlay.valid
			P_KillMobj(player.mun_chargeoverlay)
		end
		local o = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_OVERLAY)
		o.state = S_BULLETCHARGE
		o.target = player.mo
		o.color = player.mo.color
		player.mun_chargeoverlay = o
		
		S_StartSound(player.mo,sfx_spndsh)
	end
	return true
end)

local function SMFMteleport(mobj,newmobj,zoffs,gravflip)
	if gravflip --shut up!
		if (mobj.eflags & MFE_VERTICALFLIP)
			newmobj.eflags = $|MFE_VERTICALFLIP
			newmobj.flags2 = $|MF2_OBJECTFLIP
		else
			newmobj.eflags = $&~MFE_VERTICALFLIP
			newmobj.flags2 = $&~MF2_OBJECTFLIP
		end
	end

	if (mobj.eflags & MFE_VERTICALFLIP)
		local elementheight = FixedMul(newmobj.info.height,mobj.scale)
		return (mobj.z + mobj.height - zoffs - elementheight)
	else
		return mobj.z + zoffs
	end
end

addHook("PlayerThink", function(player)
	if not (player.valid and player.mo and player.mo.valid) then return end
	if (player.charability != CA_THOK) then return end
	
	player.mun_starthold = $ or 0
	player.mun_dashstop = $ or 0
	
	if player.playerstate == PST_REBORN
		player.mun_starthold = 0
		player.mun_dashstop = 0
		if player.mun_chargeoverlay and player.mun_chargeoverlay.valid
			P_KillMobj(player.mun_chargeoverlay)
			player.mun_chargeoverlay = nil
		end
		if player.mun_reticle and player.mun_reticle.valid
			P_KillMobj(player.mun_reticle)
			player.mun_reticle = nil
		end
	end
	
	if player.mun_starthold
		player.mun_starthold = max($-1,0)
		if P_IsObjectOnGround(player.mo)
			player.mun_starthold = 0
			if player.mun_chargeoverlay and player.mun_chargeoverlay.valid
				P_KillMobj(player.mun_chargeoverlay)
				player.mun_chargeoverlay = nil
			end
			if player.mun_reticle and player.mun_reticle.valid
				P_KillMobj(player.mun_reticle)
				player.mun_reticle = nil
			end
			return
		end
		player.mo.momx = FixedMul($,8*FRACUNIT/9)
		player.mo.momy = FixedMul($,8*FRACUNIT/9)
		player.mo.momz = FixedMul($,8*FRACUNIT/9)
		if abs(player.mo.momz) <= FRACUNIT*2
			player.mo.momz = 0
		end
		
		local dir = min((250*player.mo.scale/TICRATE)*(TICRATE-player.mun_starthold),250*player.mo.scale)
		if not player.mun_reticle
			local rx = P_ReturnThrustX(nil,player.mo.angle,FixedMul(dir,cos(player.aiming)))
			local ry = P_ReturnThrustY(nil,player.mo.angle,FixedMul(dir,cos(player.aiming)))
			local rz = FixedMul(dir,sin(player.aiming))
			
			player.mun_reticle = P_SpawnMobjFromMobj(player.mo,rx,ry,rz,MT_PARTICLE)
			local ret = player.mun_reticle
			ret.state = S_BULLETRETICLE
			ret.momx = player.mo.momx
			ret.momy = player.mo.momy
			ret.momz = player.mo.momz
			ret.drawonlyforplayer = player
			ret.fuse = TICRATE
		elseif player.mun_reticle and player.mun_reticle.valid
			local ret = player.mun_reticle
			
			local rx = player.mo.x + P_ReturnThrustX(nil,player.mo.angle,FixedMul(dir,cos(player.aiming)))
			local ry = player.mo.y + P_ReturnThrustY(nil,player.mo.angle,FixedMul(dir,cos(player.aiming)))
			local sz = FixedMul(dir,sin(player.aiming))
			local rz = SMFMteleport(player.mo,ret,sz,true)
			
			P_MoveOrigin(ret,rx,ry,rz)
			
			ret.state = S_BULLETRETICLE
			ret.momx = player.mo.momx
			ret.momy = player.mo.momy
			ret.momz = player.mo.momz
			ret.drawonlyforplayer = player
			ret.fuse = 2
		end
		
		player.drawangle = player.mo.angle
		player.pflags = $|PF_JUMPED|PF_FORCESTRAFE
		if (player.cmd.buttons & BT_SPIN)
			player.mo.angle = $-(ANG1*player.cmd.sidemove/5) --L Stick controls
			player.aiming = $+(ANG1*player.cmd.forwardmove/5)
			player.mun_usedspin = true
		end
		
		if not (player.cmd.buttons & BT_JUMP)
			player.mun_starthold = 1
		end
		if player.mun_starthold == 1
			local spd = 250*player.mo.scale/2
			local xyspd = FixedMul(spd,cos(player.aiming))
			local zspd = FixedMul(spd,sin(player.aiming))
			player.mun_dashstop = 8
			player.mun_starthold = 0
			for i = 0,5
				local di = (250*player.mo.scale/6)*i
				
				local rx = P_ReturnThrustX(nil,player.mo.angle,FixedMul(di,cos(player.aiming)))
				local ry = P_ReturnThrustY(nil,player.mo.angle,FixedMul(di,cos(player.aiming)))
				local rz = FixedMul(di,sin(player.aiming))*P_MobjFlip(player.mo)
			
				local d = P_SpawnMobjFromMobj(player.mo,rx,ry,rz,player.thokitem)
				d.color = player.mo.color
				d.scale = 2*player.mo.scale/3 + (player.mo.scale/6)*i
				d.destscale = d.scale/2
			end
			if player.mun_chargeoverlay and player.mun_chargeoverlay.valid
				P_KillMobj(player.mun_chargeoverlay)
				player.mun_chargeoverlay = nil
			end
			if player.mun_reticle and player.mun_reticle.valid
				P_KillMobj(player.mun_reticle)
				player.mun_reticle = nil
			end
			
			S_StartSound(mo,sfx_thok)
			P_InstaThrust(player.mo,player.mo.angle,xyspd)
			P_SetObjectMomZ(player.mo,zspd*P_MobjFlip(player.mo))
			if player.mun_usedspin
				player.aiming = 0
				player.mun_usedspin = false
			end
		end
	end
	if player.mun_dashstop
		player.mun_dashstop = max($-1,0)
		if P_IsObjectOnGround(player.mo)
			player.mun_dashstop = 0
			return
		end
		local t = P_SpawnMobjFromMobj(player.mo,0,0,0,player.thokitem)
		t.color = player.mo.color
		t.scale = player.mo.scale
		t.destscale = t.scale/2
		if player.mun_dashstop <= 5
		and player.mun_dashstop >= 3
			player.mo.momx = $/2
			player.mo.momy = $/2
			player.mo.momz = $/3
		end
	end
end)

addHook("MobjDamage", function(mo,mobj,src,dmg,dmgtype)
	if not (mo and mo.valid) then return end
	if not (mo.flags & MF_SHOOTABLE) then return end
	if not (mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)) then return end
	
	if not (mobj and mobj.valid) then return end
	if not (mobj.player and mobj.player.valid) then return end
	
	if mobj.player.mun_dashstop
		mobj.player.pflags = $&~PF_THOKKED
		return
	end
end)